package ok;

import java.sql.*;
import java.util.Vector;
import DBConnectionManager;

public class NewArticles {
	private Vector articles;
	private String bbsid;
	private String tableName  ="kboard";
	private int row=10;  // pageSize
	
	public NewArticles(String t, int r) {
		bbsid = t;
		row = r;
		articles = new Vector();
	}
	
	public Vector getArticles() {
		return articles;
	}
	
	public void setNewList() throws ClassNotFoundException, SQLException {
		DBConnectionManager connMgr;
		connMgr = DBConnectionManager.getInstance();
		Connection pconn = connMgr.getConnection("okjspdb");
		PreparedStatement pstmt = null;
		ResultSet rs = null;

		try {
			int       seq      = 0;          
			int       ref      = 0;
			int       step     = 0;
			int       lev      = 0;
			String    bwriter  = "";    
			String    subject  = "";   
			String    password = "";
			String    email    = "";
			int       read     = 0;
			String    fileName = "";
			String    maskName = "";
			long      fileSize = 0;
			int       download = 0;
			Timestamp when     = null;   
			String    ip       = "";
			Article   article;
			
			// Խù Ʈ 
			String query = "SELECT SEQ, LEV, WRITER, SUBJECT, WHEN FROM "+tableName+" WHERE BBSID=? ORDER BY WHEN DESC";
			query = "SELECT SEQ, LEV, WRITER, SUBJECT, WHEN FROM ("+query+") WHERE ROWNUM <= ?";

			pstmt = pconn.prepareStatement(query);
			pstmt.setString(1,bbsid);
			pstmt.setInt(2,row);

			rs = pstmt.executeQuery();
			
			while(rs.next()) {
				seq      = rs.getInt("SEQ");          
				lev      = rs.getInt("LEV");          
				bwriter  = rs.getString("WRITER");    
				subject  = rs.getString("SUBJECT");   
				when     = rs.getTimestamp("WHEN");   
				article  = new Article(seq, ref, step, lev, bwriter, subject, password, email, read, fileName, maskName, fileSize, download, when, ip);
				articles.add(article);
			} // end while
		} catch (SQLException e) {
			throw e;
		} finally {
			if (rs !=null) rs.close();
			if (pstmt !=null) pstmt.close();
			connMgr.freeConnection("okjspdb", pconn);
		} // end try
	}  // end setNewList()
}  // end NewArticles

