package ok;

import java.sql.*;

public class Article {
	private int seq;
	private int ref;
	private int step;
	private int lev;
	private String writer;
	private String subject;
	private String password;
	private String email;
	private int read;
	private String fileName;
	private String maskName;
	private double fileSize;
	private int download;
	private Timestamp when;
	private String ip;

	public Article(int seq, int ref, int step, int lev, String writer, String subject, String password, String email, int read, String fileName, String maskName, double fileSize, int download, Timestamp when, String ip) {
		read = 0;
		setContents(seq, ref, step, lev, writer, subject, password, email, read, fileName, maskName, fileSize, download, when, ip);
	}

	public void setContents(int seq, int ref, int step, int lev, String writer, String subject, String password, String email, int read, String fileName, String maskName, double fileSize, int download, Timestamp when, String ip) {
		this.seq=     seq;
		this.ref=     ref;
		this.step=    step;
		this.lev=     lev;
		this.writer=  writer;
		this.subject= subject;
		this.password=password;
		this.email=   email;
		this.read=    read;
		this.fileName=fileName;
		this.maskName=maskName;
		this.fileSize=fileSize;
		this.download=download;
		this.when=    when;
		this.ip=      ip;
	}
	
// setters
	public void setSeq(int seq) {
		this.seq=     seq;
	}
	
	public void setRef(int ref) {
		this.ref=     ref;
	}
	
	public void setStep(int step) {
		this.step=    step;
	}

	public void setLev(int lev) {
		this.lev=     lev;
	}
	
	public void setWriter(String writer) {
		this.writer=  writer;
	}
	
	public void setSubject(String subject) {
		this.subject= subject;
	}
	
	public void setPassword(String password) {
		this.password=password;
	}
	
	public void setEmail(String email) {
		this.email=   email;
	}
	
	public void setRead(int read) {
		this.read=    read;
	}
	
	public void setFileName(String fileName) {
		this.fileName=fileName;
	}
	
	public void setMaskName(String maskName) {
		this.maskName=maskName;
	}
	
	public void setFileSize(double fileSize) {
		this.fileSize=fileSize;
	}
	
	public void setDownload(int download) {
		this.download=download;
	}
	
	public void setWhen(Timestamp when) {
		this.when=    when;
	}
	
	public void setIp(String ip) {
		this.ip=      ip;
	}

// getters
	public int getSeq() {
		return this.seq;
	}
	
	public int getRef() {
		return this.ref;
	}
	
	public int getStep() {
		return this.step;
	}

	public int getLev() {
		return this.lev;
	}
	
	public String getWriter() {
		return this.writer;
	}
	
	public String getSubject() {
		return this.subject;
	}
	
	public String getPassword() {
		return this.password;
	}
	
	public String getEmail() {
		return this.email;
	}
	
	public int getRead() {
		return this.read;
	}
	
	public String getFileName() {
		return this.fileName;
	}
	
	public String getMaskName() {
		return this.maskName;
	}
	
	public double getFileSize() {
		return this.fileSize;
	}
	
	public int getDownload() {
		return this.download;
	}
	
	public Timestamp getWhen() {
		return this.when;
	}
	
	public String getIp() {
		return this.ip;
	}
}
