package ok;

import java.sql.*;
import java.util.Vector;

public class ArticleList {
	private Vector articles;
	private String bbsid;
	private String DB_URL     ="jdbc:oracle:thin:@127.0.0.1:1521:okjsp";
	private String DB_USER    ="scott";
	private String DB_PASSWORD="tiger";
	private String tableName  ="kboard";
	private int row=10;  // pageSize
	private int pg;
	private int total;
	
	public ArticleList(String t, int p) {
		bbsid = t;
		pg = p;
		articles = new Vector();
	}

	public ArticleList(String t, int p, int r) {
		bbsid = t;
		pg = p;
		row = r;
		articles = new Vector();
	}
	
	public Vector getArticles() {
		return articles;
	}
	
	public String getBbsid() {
		return bbsid;
	}

	public int getTotal() {
		return total;
	}
	
	public void setNewList() throws ClassNotFoundException, SQLException {
		Class.forName("oracle.jdbc.driver.OracleDriver");
		
		Connection pconn = null;
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		
		try {
			int       seq      = 0;          
			int       ref      = 0;
			int       step     = 0;
			int       lev      = 0;
			String    bwriter  = "";    
			String    subject  = "";   
			String    password = "";
			String    email    = "";
			int       read     = 0;
			String    fileName = "";
			String    maskName = "";
			long      fileSize = 0;
			int       download = 0;
			Timestamp when     = null;   
			String    ip       = "";
			Article   article;
			
			pconn = DriverManager.getConnection(DB_URL,DB_USER,DB_PASSWORD);
			
/*			// üԽù 
			total = 0;
			String querytotal = "select count(*) from "+tableName+" where bbsid=?";
			pstmt = pconn.prepareStatement(querytotal);
			pstmt.setString(1,bbsid);
			rs = pstmt.executeQuery();
			
			if(rs.next())
				total = rs.getInt(1);
			rs.close();
			pstmt.close();
			int pageTotal = (total-1)/row;
			if (pg<0) pg=0;
			if (pg>pageTotal) pg=pageTotal;
*/			


			// Խù Ʈ 
			String indexq = "/*+ index_desc("+tableName+" idx_"+tableName+") */";
			String query = "select "+indexq+" rownum rseq, seq, ref, lev, writer, subject, password, email, read, filename, maskname, filesize, download, when, ip from "+tableName+" where bbsid=? order by when desc";
			query = "select * from ("+query+") where rownum <=?";
//			query = "select * from ("+query+") where rseq between ? and ?";
			//
			int start = pg * row;
			int end = start + row;

			pstmt = pconn.prepareStatement(query);
			pstmt.setString(1,bbsid);
			pstmt.setInt(2,row);
//			pstmt.setInt(2,start+1);
//			pstmt.setInt(3,end);
			rs = pstmt.executeQuery();
			
			while(rs.next()) {
				seq      = rs.getInt("SEQ");          
				ref      = rs.getInt("REF");          
				step     = 0;//rs.getInt("STEP");         
				lev      = rs.getInt("LEV");          
				bwriter  = rs.getString("WRITER");    
				subject  = rs.getString("SUBJECT");   
				password = rs.getString("PASSWORD");  
				email    = rs.getString("EMAIL");     
				read     = rs.getInt("READ");         
				fileName = rs.getString("FILENAME");  
				maskName = rs.getString("MASKNAME");  
				fileSize = rs.getLong("FILESIZE");    
				download = rs.getInt("DOWNLOAD");     
				when     = rs.getTimestamp("WHEN");   
				ip       = rs.getString("IP");        
				article = new Article(seq, ref, step, lev, bwriter, subject, password, email, read, fileName, maskName, fileSize, download, when, ip);
				articles.add(article);
			} // end while
		} catch (SQLException e) {
			throw e;
		} finally {
			if (rs !=null) rs.close();
			if (pstmt !=null) pstmt.close();
			if (pconn !=null) pconn.close();
		} // end try
	}  // end setNewList()
}  // end ArticleList

